from collections import namedtuple
import traceback
import MySQLdb


class Database:

    def __init__(self, host, user, pwd, database):
        self.host = host
        self.user = user
        self.pwd = pwd
        self.database = database
        self.db = MySQLdb.connect(self.host, self.user, self.pwd, self.database)
        self.db.autocommit(True)
        self.cursor = self.db.cursor()
        self.cursor.execute('SET NAMES utf8;')
        self.db.set_character_set('utf8')

    def __del__(self):
        self.db.close()

    def insert(self, query, data):
        try:
            self.cursor.execute(query, (data))
            self.db.commit()
            return self.cursor.lastrowid
        except:
            print(query, data)
            traceback.print_exc()
        #     self.cursor.rollback()

    def insert_many(self, query, data):
        try:
            for i in data:
                self.cursor.execute(query, i)
            self.db.commit()
        except Exception as e:
            print(e)

    def select(self, item):
        try:
            self.cursor.execute(item)
            return self.cursor.fetchall()
        except:
            self.cursor.rollback()

    def update(self, query, data):
        self.cursor.execute(query, (data))
        self.db.commit()
        return self.cursor.lastrowid


if __name__ == '__main__':
    from datetime import datetime
    date = datetime.now()
    select = 'SELECT id, name, country FROM wp_esi_entity WHERE id < 10'
    q = """INSERT INTO wp_esi_news (title, description, URL, media_id, type_id, region_id, post_id, publish_date)
                VALUES(%s, %s, %s, %s, %s, %s, %s, %s);"""
    data = ('asdsdasd', 'sadsadsad', 'sadsadsad', 43, 2, 2, 0, date.date())
    db = Database('localhost', 'root', 'andrew', 'esi')
    # rows = db.select(select)
    id = db.insert(q, data)
    print(id)
